/* Generated by wayland-scanner 1.21.0 */

#ifndef DDE_SHELL_SERVER_PROTOCOL_H
#define DDE_SHELL_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_dde_shell The dde_shell protocol
 * @section page_ifaces_dde_shell Interfaces
 * - @subpage page_iface_dde_surface_manager - get shell surface info
 * - @subpage page_iface_dde_shell_surface - dde shell surface
 * @section page_copyright_dde_shell Copyright
 * <pre>
 *
 * Copyright (C) 2020 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     zccrs <zccrs@live.com>
 * Maintainer: zccrs <zhangjide@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * </pre>
 */
struct dde_shell_surface;
struct dde_surface_manager;
struct wl_surface;

#ifndef DDE_SURFACE_MANAGER_INTERFACE
#define DDE_SURFACE_MANAGER_INTERFACE
/**
 * @page page_iface_dde_surface_manager dde_surface_manager
 * @section page_iface_dde_surface_manager_desc Description
 *
 * Eg: window position.
 * @section page_iface_dde_surface_manager_api API
 * See @ref iface_dde_surface_manager.
 */
/**
 * @defgroup iface_dde_surface_manager The dde_surface_manager interface
 *
 * Eg: window position.
 */
extern const struct wl_interface dde_surface_manager_interface;
#endif
#ifndef DDE_SHELL_SURFACE_INTERFACE
#define DDE_SHELL_SURFACE_INTERFACE
/**
 * @page page_iface_dde_shell_surface dde_shell_surface
 * @section page_iface_dde_shell_surface_desc Description
 *
 *
 * @section page_iface_dde_shell_surface_api API
 * See @ref iface_dde_shell_surface.
 */
/**
 * @defgroup iface_dde_shell_surface The dde_shell_surface interface
 *
 *
 */
extern const struct wl_interface dde_shell_surface_interface;
#endif

/**
 * @ingroup iface_dde_surface_manager
 * @struct dde_surface_manager_interface
 */
struct dde_surface_manager_interface {
	/**
	 * get a dde surface of the surface
	 *
	 * the dde surface contains window geometry interface.
	 */
	void (*get_surface)(struct wl_client *client,
			    struct wl_resource *resource,
			    uint32_t id,
			    struct wl_resource *surface);
};


/**
 * @ingroup iface_dde_surface_manager
 */
#define DDE_SURFACE_MANAGER_GET_SURFACE_SINCE_VERSION 1

/**
 * @ingroup iface_dde_shell_surface
 * @struct dde_shell_surface_interface
 */
struct dde_shell_surface_interface {
	/**
	 * request get the window geometry
	 *
	 * reques windo geometry, will notify by "geometry" event.
	 */
	void (*get_geometry)(struct wl_client *client,
			     struct wl_resource *resource);
	/**
	 * set a property of window
	 *
	 * the property value is json format string.
	 * @param name property name
	 * @param value property value
	 */
	void (*set_property)(struct wl_client *client,
			     struct wl_resource *resource,
			     const char *name,
			     struct wl_array *value);
	/**
	 * request get a property of window
	 *
	 * the property value is json format string.
	 * @param name property name
	 */
	void (*get_property)(struct wl_client *client,
			     struct wl_resource *resource,
			     const char *name);
};

#define DDE_SHELL_SURFACE_GEOMETRY 0
#define DDE_SHELL_SURFACE_PROPERTY 1

/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GET_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_SET_PROPERTY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GET_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_dde_shell_surface
 * Sends an geometry event to the client owning the resource.
 * @param resource_ The client's resource
 * @param x x pos
 * @param y y pos
 * @param w width
 * @param h height
 */
static inline void
dde_shell_surface_send_geometry(struct wl_resource *resource_, int32_t x, int32_t y, int32_t w, int32_t h)
{
	wl_resource_post_event(resource_, DDE_SHELL_SURFACE_GEOMETRY, x, y, w, h);
}

/**
 * @ingroup iface_dde_shell_surface
 * Sends an property event to the client owning the resource.
 * @param resource_ The client's resource
 * @param name property name
 * @param value property value
 */
static inline void
dde_shell_surface_send_property(struct wl_resource *resource_, const char *name, struct wl_array *value)
{
	wl_resource_post_event(resource_, DDE_SHELL_SURFACE_PROPERTY, name, value);
}

#ifdef  __cplusplus
}
#endif

#endif
